#!/usr/bin/microperl -w


require "status/site.pm";
require "status/devices.pm";
require "status/wlan.pm";
require "status/environment.pm";

# -----------------
# CGI-Env
my %ENV = &get_env();
my %form_value = &parse_from_data(%ENV);
# -----------------

&try_function_status();

&print_site_header();
&print_menu_left(%ENV);
&print_menu_main(%form_value);


print "</body>\n</html>\n";




#-------------------------------------
#
# Sub
#
#-------------------------------------



#-------------------------------------
sub try_function_status {
  # allgeminer gestalten
   if(defined($form_value{'OpenVPN'})) {
     &function_status('OpenVPN', $form_value{'OpenVPN'});
   }
   elsif(defined($form_value{'Reboot'})) {
     &function_status('Reboot', $form_value{'Reboot'});
   }
   elsif(defined($form_value{'AP'})) {
     &function_status('AP', $form_value{'AP'});
   }

}

#-------------------------------------
sub function_status {
  my ($function, $status) = @_;

  if ($function eq 'OpenVPN') {
    # aus sicherheitsgruenden pruefen
    if(($status eq 'restart')
       || ($status eq 'stop')
       || ($status eq 'start')) {
      system("/etc/init.d/S55openvpn $status");
    }
  }
  elsif($function eq 'Reboot') {
    if(($status eq 'reboot') || ($status eq 'halt')) {
      system("$status");
    }
  }
  elsif($function eq 'AP') {
    if($status =~ m/^..:..:..:..:..:..$/) {
      system("/usr/sbin/iwconfig eth1 ap $status");
    }
  }
}


#-------------------------------------
sub print_function_status {
   my ($function) = @_;

   if ($function eq 'OpenVPN') {
     print "<tr><td width=\"200\">OpenVPN</td>\n";
     print "<td><form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
     print "<input type=\"submit\" name=\"OpenVPN\" value=\"start\">\n";
     print "<input type=\"submit\" name=\"OpenVPN\" value=\"stop\">\n";
     print "<input type=\"submit\" name=\"OpenVPN\" value=\"restart\">\n";
     print "</form></td></tr>\n";
   }
   elsif ($function eq 'Reboot') {
     print "<tr><td>System Reboot</td>\n";
     print "<td><form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
     print "<input type=\"submit\" name=\"Reboot\" value=\"halt\">\n";
     print "<input type=\"submit\" name=\"Reboot\" value=\"reboot\">\n";
     print "</form></td></tr>\n";
   }
}


#-------------------------------------
sub uptime_status {
  my $pid;
  my $out;

  $pid = open(UPTIME, "/usr/bin/uptime |") or die;
  $out = <UPTIME>;
  close (UPTIME);

 return($out);
}

#-------------------------------------
sub print_mount_status {
  my $pid;
  my @out;
  my $line;

  $pid = open(MOUNT, "/bin/mount |") or die;
  @out = <MOUNT>;
  close (MOUNT);

  foreach $line (@out) {
    print $line."<br>\n";
  }

  # df
  $pid = open(MOUNT, "df -h |") or die;
  @out = <MOUNT>;
  close (MOUNT);

  print "<p><pre>";
  foreach $line (@out) {
    print $line;
  }
  print "</pre></p>\n";

  return();
}



